#include <EEPROM.h>

//  Spectro_lineCommand
//
//  Read the Spectrometer Value when "s\r" is received 
//   and plot as a graph  
//
//  mykepredko.mimetics.ca

int    serialByte  = 0;           //  For incoming serial data
int    commandByte = 0;           //  Command to Execute
int    x;                         //  Stored Value for ADC Read
int    i;
int    j;
String percentageValue;
int    ledPins[]   = {            //  LED IO Pins
                       2          //  Blue
                    ,  4          //  Green
                    ,  6          //  Amber
                    ,  8          //  Red
                    , 10          //  IR 880nm
                    , 12          //  IR 940nm
                     };
int    ledValues[] = {            //  LED IO Pins
                       0          //  Ambient
                    ,  0          //  Blue
                    ,  0          //  Green
                    ,  0          //  Amber
                    ,  0          //  Red
                    ,  0          //  IR 880nm
                    ,  0          //  IR 940nm
                     };
String ADCvalue[]  = {
                       ""
                    ,  ""
                    ,  ""
                    ,  ""
                    ,  ""
                    ,  ""
                    ,  ""
                      };

void setup() {

    Serial.begin(9600);           //  Setup Serial library at 9600 bps
    
    pinMode(A0, INPUT);           //  Setup OTPT101P Analog Input    
    
    pinMode(ledPins[0],  OUTPUT);  digitalWrite(ledPins[0],  LOW);  //  Setup the LED IO Pins
    pinMode(ledPins[1],  OUTPUT);  digitalWrite(ledPins[1],  LOW);  
    pinMode(ledPins[2],  OUTPUT);  digitalWrite(ledPins[2],  LOW);  
    pinMode(ledPins[3],  OUTPUT);  digitalWrite(ledPins[3],  LOW);  
    pinMode(ledPins[4],  OUTPUT);  digitalWrite(ledPins[4],  LOW);  
    pinMode(ledPins[5],  OUTPUT);  digitalWrite(ledPins[5],  LOW);  
    
}

void loop() {

    if (0 < Serial.available()) {
        serialByte = Serial.read();
        if ((0x0D == serialByte) && (0 != commandByte)) {       //  Carriage Return
            Serial.write(27);  Serial.print("[2J");             //  VT100 Clear Screen
            Serial.write(27);  Serial.print("[H");              //  VT100 Move to Top Left Corner
            Serial.print("Spectrometer plot: ");  
            Serial.print("\r\n");
            ledValues[0] = analogRead(A0) / 8;
            if (100 < ledValues[0]) {
                ledValues[0] = 100;
            }
            for (ADCvalue[0] = String(ledValues[0]); 3 > ADCvalue[0].length(); 
                        ADCvalue[0] = String(" " + ADCvalue[0])) {
            }
            for (i = 1; 7 > i; ++i) {
                digitalWrite(ledPins[i - 1], HIGH);
                delay(10);
                ledValues[i] = analogRead(A0) / 3;
                if (100 < ledValues[i]) {
                    ledValues[i] = 100;
                }
                for (ADCvalue[i] = String(ledValues[i]); 3 > ADCvalue[i].length(); 
                        ADCvalue[i] = String(" " + ADCvalue[i])) {
                }
                digitalWrite(ledPins[i - 1], LOW);
                delay(10);
            }
            for (i = 20; 0 < i; --i) {
                Serial.print("  ");
                if (0 == (i % 2)) {                             //  Print Every 10%
                    for (percentageValue = String(i * 5); 3 > percentageValue.length(); 
                            percentageValue = " " + percentageValue) {
                    }              
                    Serial.print(percentageValue);
                    Serial.print("% |  ");
                }
                else {
                    Serial.print("     |  ");
                }
                for (j = 0; 7 > j; ++j) {
                    if (((i * 5) >= ledValues[j]) && (((i - 1) * 5) < ledValues[j])) {
                        Serial.print("-*-");
                    }
                    else {
                        Serial.print("   ");
                    }
                    Serial.print("    ");
                }
                Serial.print("\r\n");
            }
            Serial.print("       |---------------------------------------------------\r\n");
            Serial.print("          ");
            for (i = 0; 7 > i; ++i) {
                Serial.print(ADCvalue[i]);
                Serial.print("    ");
            }
            Serial.print("\r\n");
            Serial.print("          Amb    470nm  527nm  591nm  621nm  880nm  940nm\r\n");
            commandByte = 0;
        }
        else if (0x08 == serialByte) {                          //  Backspace
            commandByte = 0;                                    //  Clear the active Command
        }
        else if (('s' == serialByte) && (0 == commandByte)) {   //  Save the Command
            commandByte = serialByte;  
        }
    }
}
