#include <EEPROM.h>

//  Spectro_lineOutput
//
//  Read the Spectrometer Value when "s\r" is received 
//
//  mykepredko.mimetics.ca

int    serialByte  = 0;           //  For incoming serial data
int    commandByte = 0;           //  Command to Execute
int    x;                         //  Stored Value for ADC Read
int    ledValue;
int    i;
int    j;
String percentageValue;
String ADCvalue;
int    ledPins[]   = {            //  LED IO Pins
                       2          //  Blue
                    ,  4          //  Green
                    ,  6          //  Amber
                    ,  8          //  Red
                    , 10          //  IR 880nm
                    , 12          //  IR 940nm
                     };

void setup() {

    Serial.begin(9600);           //  Setup Serial library at 9600 bps
    
    pinMode(A0, INPUT);           //  Setup OTPT101P Analog Input    
    
    pinMode(ledPins[0],  OUTPUT);  digitalWrite(ledPins[0],  LOW);  //  Setup the LED IO Pins
    pinMode(ledPins[1],  OUTPUT);  digitalWrite(ledPins[1],  LOW);  
    pinMode(ledPins[2],  OUTPUT);  digitalWrite(ledPins[2],  LOW);  
    pinMode(ledPins[3],  OUTPUT);  digitalWrite(ledPins[3],  LOW);  
    pinMode(ledPins[4],  OUTPUT);  digitalWrite(ledPins[4],  LOW);  
    pinMode(ledPins[5],  OUTPUT);  digitalWrite(ledPins[5],  LOW);  
   
    Serial.write(27);  Serial.print("[2J");             //  VT100 Clear Screen
    Serial.write(27);  Serial.print("[H");              //  VT100 Move to Top Left Corner
 
}

void loop() {

    if (0 < Serial.available()) {
        serialByte = Serial.read();
        if ((0x0D == serialByte) && (0 != commandByte)) {       //  Carriage Return
            ledValue = analogRead(A0);
            if (800 < ledValue) {
                ADCvalue = "100";
            }
            else {
                for (ADCvalue = String(ledValue / 8); 3 > ADCvalue.length(); 
                            ADCvalue = String("0" + ADCvalue)) {
                }
            }
            Serial.print(ADCvalue);
            for (i = 1; 7 > i; ++i) {
                Serial.print("-");
                digitalWrite(ledPins[i - 1], HIGH);
                delay(10);
                ledValue = analogRead(A0);
                ledValue /= 3;
                if (100 < ledValue) {
                    ledValue = 100;
                }
                for (ADCvalue = String(ledValue); 3 > ADCvalue.length(); 
                        ADCvalue = String("0" + ADCvalue)) {
                }
                digitalWrite(ledPins[i - 1], LOW);
                delay(10);
                Serial.print(ADCvalue);
            }
            Serial.print("\r\n");
            commandByte = 0;
        }
        else if (0x08 == serialByte) {                          //  Backspace
            commandByte = 0;                                    //  Clear the active Command
        }
        else if (('s' == serialByte) && (0 == commandByte)) {   //  Save the Command
            commandByte = serialByte;  
        }
    }
}
